Module Header
    Public Const CTRL As Integer = 128
    Public Const ALT As Integer = 256

    ' Key codes for function keys, numbers, and hex digits are their
    ' ASCII equivalents
    Public Const K_A As Integer = 97       'a
    Public Const K_B As Integer = 98       'b
    Public Const K_C As Integer = 99       'c
    Public Const K_D As Integer = 100      'd
    Public Const K_E As Integer = 101      'e
    Public Const K_F As Integer = 102      'f
    Public Const K_7 As Integer = 55       '7
    Public Const K_8 As Integer = 56       '8
    Public Const K_9 As Integer = 57       '9
    Public Const K_DIV As Integer = 47     '/
    Public Const K_GSB As Integer = 71     'G
    Public Const K_GTO As Integer = 116    't (gTo)
    Public Const K_HEX As Integer = 104    'h
    Public Const K_DEC As Integer = 68     'D
    Public Const K_OCT As Integer = 111    'o
    Public Const K_BIN As Integer = 66     'B
    Public Const K_4 As Integer = 52       '4
    Public Const K_5 As Integer = 53       '5
    Public Const K_6 As Integer = 54       '6
    Public Const K_MULT As Integer = 42    '*
    Public Const K_RS As Integer = 82      'R
    Public Const K_SST As Integer = 83     'S
    Public Const K_ROL As Integer = 108    'l (roL)
    Public Const K_XY As Integer = 120     'x
    Public Const K_BSP As Integer = 8      '\b
    Public Const K_ENTER As Integer = 13   '\r
    Public Const K_1 As Integer = 49       '1
    Public Const K_2 As Integer = 50       '2
    Public Const K_3 As Integer = 51       '3
    Public Const K_MINUS As Integer = 45    '-
    Public Const K_ON As Integer = 113     'q (Quit)
    Public Const K_FKEY As Integer = 1     ' ctrl key
    Public Const K_GKEY As Integer = 2     ' alt key
    Public Const K_STO As Integer = 115    's
    Public Const K_RCL As Integer = 114    'r
    Public Const K_0 As Integer = 48       '0
    Public Const K_DP As Integer = 46      '.
    Public Const K_CHS As Integer = 67     'C
    Public Const K_PLUS As Integer = 43    '+

    ' Key codes for the yellow (cntrl) functions are created by adding
    ' 128 to the K_ codes above
    Public Const F_SL As Integer = CTRL + K_A
    Public Const F_SR As Integer = CTRL + K_B
    Public Const F_RL As Integer = CTRL + K_C
    Public Const F_RR As Integer = CTRL + K_D
    Public Const F_RLN As Integer = CTRL + K_E
    Public Const F_RRN As Integer = CTRL + K_F
    Public Const F_MASKL As Integer = CTRL + K_7
    Public Const F_MASKR As Integer = CTRL + K_8
    Public Const F_RMD As Integer = CTRL + K_9
    Public Const F_XOR As Integer = CTRL + K_DIV
    Public Const F_XIND As Integer = CTRL + K_GSB
    Public Const F_XI As Integer = CTRL + K_GTO
    Public Const F_SHEX As Integer = CTRL + K_HEX
    Public Const F_SDEC As Integer = CTRL + K_DEC
    Public Const F_SOCT As Integer = CTRL + K_OCT
    Public Const F_SBIN As Integer = CTRL + K_BIN
    Public Const F_SB As Integer = CTRL + K_4
    Public Const F_CB As Integer = CTRL + K_5
    Public Const F_BSET As Integer = CTRL + K_6
    Public Const F_AND As Integer = CTRL + K_MULT
    Public Const F_IND As Integer = CTRL + K_RS
    Public Const F_I As Integer = CTRL + K_SST
    Public Const F_CPGRM As Integer = CTRL + K_ROL
    Public Const F_CREG As Integer = CTRL + K_XY
    Public Const F_CPRE As Integer = CTRL + K_BSP
    Public Const F_WIN As Integer = CTRL + K_ENTER
    Public Const F_S1S As Integer = CTRL + K_1
    Public Const F_S2S As Integer = CTRL + K_2
    Public Const F_SUNS As Integer = CTRL + K_3
    Public Const F_NOT As Integer = CTRL + K_MINUS
    ' ON
    ' FKEY
    ' GKEY
    Public Const F_WSIZE As Integer = CTRL + K_STO
    Public Const F_FLOAT As Integer = CTRL + K_RCL
    Public Const F_MEM As Integer = CTRL + K_0
    Public Const F_STAT As Integer = CTRL + K_DP
    Public Const F_EEX As Integer = CTRL + K_CHS
    Public Const F_OR As Integer = CTRL + K_PLUS

    ' Key codes for the blue (alt) functions are created by adding 256
    ' to the K_* values
    Public Const G_LJ As Integer = ALT + K_A
    Public Const G_ASR As Integer = ALT + K_B
    Public Const G_RLC As Integer = ALT + K_C
    Public Const G_RRC As Integer = ALT + K_D
    Public Const G_RLCN As Integer = ALT + K_E
    Public Const G_RRCN As Integer = ALT + K_F
    Public Const G_BITS As Integer = ALT + K_7
    Public Const G_ABS As Integer = ALT + K_8
    Public Const G_DBLR As Integer = ALT + K_9
    Public Const G_DDIV As Integer = ALT + K_DIV
    Public Const G_RTN As Integer = ALT + K_GSB
    Public Const G_LBL As Integer = ALT + K_GTO
    Public Const G_DSZ As Integer = ALT + K_HEX
    Public Const G_ISZ As Integer = ALT + K_DEC
    Public Const G_SQRT As Integer = ALT + K_OCT
    Public Const G_INV As Integer = ALT + K_BIN
    Public Const G_SF As Integer = ALT + K_4
    Public Const G_CF As Integer = ALT + K_5
    Public Const G_FSET As Integer = ALT + K_6
    Public Const G_DMUL As Integer = ALT + K_MULT
    Public Const G_PR As Integer = ALT + K_RS
    Public Const G_BST As Integer = ALT + K_SST
    Public Const G_RUP As Integer = ALT + K_ROL
    Public Const G_PSE As Integer = ALT + K_XY
    Public Const G_CLX As Integer = ALT + K_BSP
    Public Const G_LSTX As Integer = ALT + K_ENTER
    Public Const G_XGEY As Integer = ALT + K_1
    Public Const G_XL0 As Integer = ALT + K_2
    Public Const G_XGY As Integer = ALT + K_3
    Public Const G_XG0 As Integer = ALT + K_MINUS
    ' ON
    ' FKEY
    ' GKEY
    Public Const G_WLEFT As Integer = ALT + K_STO
    Public Const G_WRIGHT As Integer = ALT + K_RCL
    Public Const G_XNEY As Integer = ALT + K_0
    Public Const G_XNE0 As Integer = ALT + K_DP
    Public Const G_XEY As Integer = ALT + K_CHS
    Public Const G_XE0 As Integer = ALT + K_PLUS

    ' General constants
    Public Const STACK_SIZE As Integer = 4
    Public Const REG_SIZE As Integer = 32
    Public Const SCREEN_SIZE As Integer = 38
    Public Const FLOAT_MODE As Integer = 0
    Public Const HEX_MODE As Integer = 1
    Public Const DEC_MODE As Integer = 2
    Public Const OCT_MODE As Integer = 3
    Public Const BIN_MODE As Integer = 4

    ' Sign mode
    Public Const SIGN_UNSIGNED As Integer = 0
    Public Const SIGN_1S_COMPLEMENT As Integer = 1
    Public Const SIGN_2S_COMPLEMENT As Integer = 2

    ' Number of digits at 64 bits
    Public Const MAX_FLOAT_DIGITS As Integer = SCREEN_SIZE - 1
    Public Const MAX_HEX_DIGITS As Integer = 16
    Public Const MAX_OCTAL_DIGITS As Integer = 23
    Public Const MAX_DECIMAL_DIGITS As Integer = 19
    Public Const MAX_BINARY_DIGITS As Integer = 64

    ' Display flags
    Public Const DFLAG_FKEY As Integer = 0
    Public Const DFLAG_GKEY As Integer = 1
    Public Const DFLAG_CARRYBIT As Integer = 4
    Public Const DFLAG_OVERFLOW As Integer = 5
End Module
